Pcap_DNSProxy 0.4.9.10-0.4.9.13 更新日誌(2018-12-30)：

* 添加實驗性 FreeBSD 平臺支援 [Meowthink]
* 添加 --log-file 參數，可在啟動時指定日誌檔的儲存位置 [LGA1150/Syrone Wong]
* 添加編譯和運行時對庫版本的檢測 [Syrone Wong/wangmice]
  * LibEvent 最低版本要求為 2.1.8
  * LibSodium 最低版本要求為 1.0.16
  * OpenSSL 最低版本要求為 1.0.2
* 重寫 Domain Test 和 ICMP Test 模組
* OpenSSL 更新到 1.1.1a (macOS)
* Xcode 更新到 10.0 (macOS)
* 參數 --config-file 改名為 --config-path
* 調整日誌檔的初始輸出為 stderr (OpenWrt) [Syrone Wong]
* 修正網域名稱解析大小寫相關問題 [muink/WeirdoShaw]
* 修正 Address Hosts 相關問題 [LGA1150]
* 修正 Domain Test 和 ICMP Test 模組的資料包序號、網路請求策略和時間間隔的問題 [LisonFan]
* 修正 SOCKS 使用者認證問題 [SunZhizhong]
* 修正 EDNS Label 過濾演算法的問題 [Justsoos]
* 修正 Hop Limits Fluctuation 參數範圍不准確的問題
* 修正腳本 echo 參數的問題 (Linux/macOS) [YKilin]
* 注意：對 Windows XP/2003 的支援將在未來一段時間完全終止，敬請留意！
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 617B77E2FC893A142A45B120DE6E81695E860633C49CE05F189CB24B1BF36EE7
    * Windows/Pcap_DNSProxy_x86.exe: 026B36EF01A9DD57853787F643D9874F2A2B88753D1128E644C5D533610CB2DD
    * Windows/Pcap_DNSProxy_XP.exe: 6A7E8F5A947E8DF871B05D7CAF86D59994A20A2699FAB1FEBF6ECDCAB068A227
    * macOS/Pcap_DNSProxy: EE48BE316727F1152636A42DB7BC6087187BF10ADC5E90C52997F9C345E34569
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: FF9A8CB56062BB8506C3E77C4603FE78CCC6FE59C916429236113368D15DA4BE
    * Windows/Pcap_DNSProxy_x86.exe: D2CF9B2FA5A215C2E39EAF30B7CA6001873A6E1F2BE0ADE6C9E7DA1551ED9313
    * Windows/Pcap_DNSProxy_XP.exe: ACB13712956168A594C97E03EE54A15B58C515E97C065CEFCA3A6214062D71CA
    * macOS/Pcap_DNSProxy: 5E4F3C7D5216BD65B85E2B34DCE88F4E9575F8B568DF73019367D5F2D9195E13


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.9.5-0.4.9.9 更新日誌(2018-07-14)：

* 添加完整的 EDNS 標籤透明轉發支援
* 添加對 libevent 庫的支援
* 添加對根據 DNS 請求類型進行轉發選路的的支援 [ccaapton]
* C++ 最低標準要求更新到 14
* LibSodium 更新到 1.0.16 (Windows/macOS)
* OpenSSL 更新到 1.1.0h (macOS)
* Strict Resource Record TTL Filter 改名為 Resource Record Set TTL Filter
* 優化編譯參數 (Linux/macOS)
* 修正 Local 請求過程參數的邏輯 [LisonFan/sysconfon/huaji0353/gitlikang]
* 修正請求協定選擇的演算法，在同時啟用 IPv6 和 IPv4 時預設將趨向以相同的協定進行請求 [ccaapton]
* 修正 EDNS Lebel 參數對 All 行為的支援 [muink]
* 修正對 DNSSEC 資料包的過濾演算法 [ZeroClover]
* 修正初始化 LibSodium 時的行為，增強安全性
* 修正抓包模組對 IPv4/IPv6 分片資料包的支援
* 修正包含 DNSSEC 相關記錄的過濾演算法
  * DNSSEC Force Validation 改名為 DNSSEC Force Record
* 修正腳本對檔描述項的軟性限制 (Linux) [lunzima]
* 修復 SOCKS 和 HTTP(S) Proxy 協定 TCP 模式下長度判斷錯誤的問題 [LisonFan/laggardkernel]
* 修复部分受支持编译器不支持 -fsplit-stack 参数导致编译失败的问题 [asd2003asd]
* 修復 SOCKS Username 和 SOCKS Password 參數讀取的問題 [ダクネスExplosion]
* 修復部分帶位址參數重複檢測邏輯錯誤的問題 [cjjdaq]
* 修復 EDNS Client Subnet 啟用時部分類型的 DNS 請求會被截斷的問題 [mewsf]
* 修復 EDNS Label 以及任何的 Force TCP 同時啟用時資料包格式出錯的問題 [chenjiajia9411]
* 修復在啟用 EDNS Label 同時收到 UDP 協定超長資料包時無法正確設置截斷標誌位的問題 [debugzxcv]
* 修復抓包模組抓取原生 IPv6 和 ICMP 協定資料包時的錯誤
* 修復 ICMP/ICMPv6 請求模組的時間控制問題
* 提升 CMake 版本要求到 3.1 (Linux/macOS)
* 移除 IPv4 Data Filter 參數
* 移除 DNSSEC Validation 參數
  * 注意：本工具從未有支援 DNSSEC 完整驗證，僅檢查是否存在 DNSSEC 相關資源記錄，而此功能已整合到 DNS Data Filter 參數中。為避免名稱上的誤導，特此移除！
* 移除對 Homebrew 的支援 (macOS)
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 462857B5E74356D783D7230F60A662F9462A36F8543E45874376B96E9C1F0FE1
    * Windows/Pcap_DNSProxy_x86.exe: 957C1EBE379E82E3B4AB87B13AAA17A715F8E0906BCC2846F1F591A5602F06A2
    * Windows/Pcap_DNSProxy_XP.exe: C69BCF482203799AF642BC48DCF78DB98B885D7D7E613BB14C1EE32A203E509D
    * macOS/Pcap_DNSProxy: 5372E067FE8941E77E210AE68C684E3019C8F887218536B2947696AF83877670
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 3E57CF4D09A28D116972B73D4A7C33E7888F4189DD35939955DEFC81C61BA732
    * Windows/Pcap_DNSProxy_x86.exe: E6CE60C25C93456DF9A70BBDB2A2D21EF40254783DC0003561AC4E89CBFC3C10
    * Windows/Pcap_DNSProxy_XP.exe: 8C363476DB55EC55AB1F96C5BB05C84E3B8602F08B9B0992C8ED26FAF8990617
    * macOS/Pcap_DNSProxy: 035D39EA32D70EDBA6B2B7FA6B6C27AB5D91E335DCD0330E5E39C97997FDC8BC


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.9.1-0.4.9.4 更新日誌(2017-10-06)：

* 添加 Domain Test 探測模組對 TCP 協定的支援
  * 添加 Domain Test Protocol 參數
* 大幅提升 Local Routing 境內路由表和內置 DNS 緩存的查詢效率 [Syrone Wong]
* LibSodium 更新到 1.0.15 (Windows/macOS)
* Xcode 更新到 9.0 (macOS)
* OpenSSL 更新到 1.1.0f (macOS)
* 調整境內伺服器請求過程的整體策略 [cjjdaq]
  * 移除 Local Main 參數
* 調整內置 IP 位址黑名單的策略
  * 警告：此次更新後所有內置的 IP 位址黑名單將移到 IPFilter 檔，請務必對 IPFilter 檔進行更新，否則有可能造成投毒污染的問題！
* 修正對 TCP 報文的探測過濾演算法
* 修正多重實例運行的問題
  * 添加 Process Unique 參數
* 修復網路模組在部分情況下導致崩潰的問題 [goxofy/kalagxw/lunzima/monokoo/pengpengxp/Syrone Wong/wangmice]
* 修復 Local Hosts 白名單識別演算法的問題 [cjjdaq/muink]
* 修復 Transaction ID 在取特殊值的情況時無法進行解析的問題 [LisonFan]
* 修復在部分情況下指定多個 Listen Address 時可能造成的錯誤報錯問題
* 修復錯誤日誌輸出模組的時間計算問題
* 修復 CNAME Hosts 網域名稱內部 Dnsmasq 格式匹配規則錯誤的問題
* 修復 NSCI 系統網路感應指示器 IPv6 位址被錯誤過濾的問題 (Windows) [hnsylzg]
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 8E9EEAFD301C1D27A1B9E6D2CAC692D032621E3E80BB15A3CCA1CCEF3768FA2D
    * Windows/Pcap_DNSProxy_x86.exe: 7EF905162AB37BCF94C229D991773DADE1DF02F635B951DCEF50976B915E4795
    * Windows/Pcap_DNSProxy_XP.exe: 4AF0131A398A75D26ADA5DACBF9E185EEBE78D2A5E4A0787DE16A66EE0496FAE
    * macOS/Pcap_DNSProxy: F5A91990F9DC3022AA016EE9E12659D64ECEF3351139CA2D0630E99CC298F06F
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 577314F84110F9531CC5E5EFA16622FBA7C0B8E0AE525DA802298A1CE90AB0DD
    * Windows/Pcap_DNSProxy_x86.exe: 6080BD47D3F32E516E1DDCDD399866C05E62D3732132C8111F8D9650C8B84FD2
    * Windows/Pcap_DNSProxy_XP.exe: 54E0E01B6EEFE0875B8DFDD3A673CA57EA6E1DF25D07A1601DECEBDC5962226F
    * macOS/Pcap_DNSProxy: 8C8A225E861517822328E264C3FAFD3E0455352D206EC106DB9FBA5E2F489669


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.8.5-0.4.9.0 更新日誌(2017-06-03)：

* 添加對根據請求來源 IP 位址有別的 DNS 緩存/每個首碼位址擁有單獨 DNS 緩存佇列的支援 [LisonFan]
  * 添加 Cache Single IPv4 Address Prefix 參數
  * 添加 Cache Single IPv6 Address Prefix 參數
* 添加對 EDNS Client Subnet Relay 啟用時前置長度跟隨固定位址的功能 [LisonFan]
* 添加對 DNSCrypt 資料庫檔案 dnscrypt-resolvers.csv 配置的支援 [rampageX/snakwu]
* 添加對 HTTP CONNECT 隧道 HTTP/2 版本的支援 [agentmario]
* 添加對 Force TCP/UDP 參數的支援，可強制請求過程只使用所指定的 TCP/UDP 協定
* 添加對 TLS ALPN 擴展的支援
* 添加對 ServiceControl.bat 啟動參數的支援，可直接通過在啟動時指定參數進行對應的操作 (Windows)
* 添加對指定 TCP Fast Open 的監聽佇列長度支援 (Linux)
* 添加對 TCP Fast Open 的支援 (macOS)
* LibSodium 庫更新到 1.0.12 (Windows/macOS)
* Visual Studio 更新到 2017 (Windows)
* 修復讀取文字檔時最後一個字元為有效字元但被忽略的問題 [冰靈曦曉]
* 修復在完全禁用 IPv6 協定棧的情況下程式依舊嘗試使用 IPv6 協定棧的問題 [dzxx36gyy]
* 修復 Cache Parameter 參數運作與說明文檔不符的問題 [LisonFan]
* 修復 EDNS Client Subnet 資料包前置長度截斷不符合標準的問題 [LisonFan]
* 修復 -c/--config-file 參數在部分情況下無法正常指定路徑的問題
* 修復在設定檔重新讀取參數有改變的情況下沒有進行網路狀況重新測試的問題
* 修復 DNSCurve(DNSCrypt) 在設定檔重新讀取參數沒有改變的情況下可能無法正常工作的問題
* 修復 HTTP CONNECT 隧道在部分伺服器先行推送資料時無法正常工作的問題
* 修復 OpenSSL 在部分情況下無法設置通訊端屬性的問題 (Linux/macOS)
* 修復在啟用 TCP Fast Open 多執行緒請求的情況下部分伺服器被跳過的問題 (Linux)
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 55692B5DD0ED42D39091EA7ADB87DA460441D9D18D07D5D87EC3739A5FD6068C
    * Windows/Pcap_DNSProxy_x86.exe: C943F0BF0691B219CED39B968FF073384DD4C3F5C6B1DF36B5072F1BA6FAFBBE
    * Windows/Pcap_DNSProxy_XP.exe: E17101A1B7DFA4AB79B4B68FF2A99C9E1260C20D13BCCB9F2ACD9E84C6C82F3A
    * macOS/Pcap_DNSProxy: 6B13BFED3EEFF32375F1E02CFE19EA4A17DD129CB4245390C698B1F8AFCEDEE0
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 13AECD65E89913DC3A9AF420872F8DFB67BA52EC1CAC5A6DD4CCCF9FF5A85234
    * Windows/Pcap_DNSProxy_x86.exe: 090B462C0751C7200A428C261D6AADE3AF455D6A8D0324617D44234C4772225C
    * Windows/Pcap_DNSProxy_XP.exe: 0998FC56226D9B8327D353366CF8FB04CED233993CFC0A561226DE385934D6B7
    * macOS/Pcap_DNSProxy: 91AF21E7B704F3894CB1AC658148BBC3019676352BC5F0524BCD2E2176BE3DF8


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.8.1-0.4.8.4 更新日誌(2017-03-11)：

* 添加 Address Hosts 的首碼長度支援 [LGA1150]
* 添加 EDNS Label 參數名單的排除模式支援 [燒香の貓咪]
* 添加 Strict Resource Record TTL Filter 參數以支援 RFC 2181 標準所要求的資源記錄 TTL 檢查
* 添加內置的單一實例限制多開支援
* 添加一組 Pcap Devices Blacklist 非必要抓包黑名單 (macOS)
* 標準化 EDNS Client Subnet 的行為
* 解除對 260 字元路徑/檔案名的內部邏輯限制，相關限制仍會受系統組態所影響 (Windows)
* 改進的 Domain Case Conversion 功能
* 改進在啟用手動版本選擇時所指定使用的 Ciphers Suites (Linux/macOS)
* Output Protocol 改名為 Outgoing Protocol
* OpenSSL 更新到 1.1.0e (macOS)
* 修改多行注釋區域的標籤要求 [Monoremonton/wx0]
* 修改全部類型 DNS 緩存的緩存策略 [kraml]
* 修復記憶體對齊可能造成的性能問題 [Syrone Wong]
* 修復 Operation Mode 參數指定為 Proxy 和 Server 模式時工作不正常的問題 [Syrone Wong/wang20150419]
* 修復預編譯二進位版本無法正確運行的錯誤 (macOS) [fysly]
* 修復在部分情況下 DNS 緩存無法以超時形式移除的問題 [kraml]
* 修復一個可能在部分編譯器造成嚴重記憶體洩漏的問題
* 修復 IPv6 位址的 Local Routing 在指定部分首碼長度時可能出現的崩潰問題
* 修復 IPv6 位址實際位址與首碼長度所指定的位址不一致的問題
* 修復多行注釋區域無法通過其它非多行注釋區域標籤重置的問題
* 修復 TCP 模式下 SOCKS Proxy 和 HTTP CONNECT Proxy 工作不正常的問題
* 修復 Local Force Request 參數在啟用 Local Main 或 Local Routing 功能時工作不正常的問題
* 修復反查本地 IPv6 位址 PTR 記錄的問題 (Windows/Linux)
* 修復 32 位系統下可能出現的計算檔佔用空間錯誤的問題 (Windows)
* 修復使用低於 OpenSSL 1.0.1 版本時指定過於嚴格的規則導致沒有任何 Ciphers Suites 可用的問題 (Linux/macOS)
* 修復記憶體對齊方式不一致可能導致的運行出錯的問題 (Linux/macOS)
* 修復在啟用 TCP Fast Open 的情況下有幾率出現的要求傳送失敗的問題 (Linux)
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: B28B1D013FE4690F809D3D1FFCA0FFAF152C9F2A3201E2596D398F90E78B2657
    * Windows/Pcap_DNSProxy_x86.exe: 04E0783F9BB6175C70EE39182BCEF2C1C3B831E78ABCF2E70641568E7098205D
    * Windows/Pcap_DNSProxy_XP.exe: DF509FDB4EC3EBDF9A734A92864E1B31C48FB102543FD1C3CD800FEB015B2DD7
    * macOS/Pcap_DNSProxy: 4C3FDC39D26EAC29E25238D15D4319230BF1631873CEF68C7EFC260B26C4F4C8
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 49295353E340B4EBB3FDBAA069C267074C81C1693A9966161B7EFE4AFBA97D1D
    * Windows/Pcap_DNSProxy_x86.exe: 565DEF67183452397957EBF24088C427A8B8DCDD20E81F27804898448D1C6C93
    * Windows/Pcap_DNSProxy_XP.exe: 12705D3715D525C6536B8E662AC648D51C839111B13950EF3ED27FD430E9445A
    * macOS/Pcap_DNSProxy: 479223CD534D4F8D9CEC0DD44AD4BC1EEB85108D5AE8FF3A6EF3AF5C6DFB1501


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.7.7-0.4.8.0 更新日誌(2016-11-23)：

* 添加 Include Guard Macros 的支援 [Syrone Wong]
* 添加 Large Buffer Size 參數，用於指定大型資料緩衝區的固定長度
* 添加串列請求通訊模組，重寫部分網路請求協定
  * 重寫 SOCKS Proxy 以及 HTTP CONNECT Proxy 協定實現，解除傳輸資料量受一次性請求通訊模組固定緩衝區的長度限制
  * 新增 Reliable Serial Socket Timeout 和 Unreliable Serial Socket Timeout 參數控制串列通訊超時時間
  * HTTP Proxy 改名為 HTTP CONNECT Proxy
  * HTTP Protocol 改名為 HTTP CONNECT Protocol
  * HTTP Proxy Only 改名為 HTTP CONNECT Proxy Only
  * HTTP IPv4 Address 改名為 HTTP CONNECT IPv4 Address
  * HTTP IPv6 Address 改名為 HTTP CONNECT IPv6 Address
  * HTTP Target Server 改名為 HTTP CONNECT Target Server
  * HTTP Version 改名為 HTTP CONNECT Version
  * HTTP Header Field 改名為 HTTP CONNECT Header Field
  * HTTP Proxy Authorization 改名為 HTTP CONNECT Proxy Authorization
  * 移除 HTTP Socket Timeout/SOCKS Reliable Socket Timeout/SOCKS Unreliable Socket Timeout 參數
* 添加 HTTP CONNECT Tunnel 單獨 TLS/SSL 握手和加密傳輸的能力
  * TLS/SSL 握手和加密傳輸由 SSPI/SChannel(Windows) 和 OpenSSL(Linux/macOS) 支援
  * 添加 HTTP CONNECT TLS Handshake 參數，用於開啟 TLS 握手功能
  * 添加 HTTP CONNECT TLS Version 參數，用於指定所使用的 TLS 版本
  * 添加 HTTP CONNECT TLS Validation 參數，用於選擇是否驗證 TLS 伺服器憑證鏈
  * 添加 HTTP CONNECT TLS Server Name Indication 參數，用於指定 TLS 握手時所使用的網域名稱
* 添加 IPFilter 和 Hosts 檔臨時停止讀取標籤的區塊化支援
* 設定檔版本要求升級到 0.45
  * Protocol 改名為 Output Protocol
  * IPv4 DNS Address 改名為 IPv4 Main DNS Address
  * IPv4 Local Main DNS Address 改名為 IPv4 Local Main DNS Address
  * IPv6 DNS Address 改名為 IPv6 Main DNS Address
  * IPv6 Local DNS Address 改名為 IPv6 Local Main DNS Address
  * IPv4 DNS TTL 改名為 IPv4 Main DNS TTL
  * IPv6 DNS Hop Limits 改名為 IPv6 Main DNS Hop Limits
  * Reliable Socket Timeout 改名為 Reliable Once Socket Timeout
  * Unreliable Socket Timeout 改名為 Unreliable Once Socket Timeout
  * Encryption 改名為 DNSCurve Encryption
  * Encryption Only 改名為 DNSCurve Encryption Only
  * Client Ephemeral Key 改名為 DNSCurve Client Ephemeral Key
  * Key Recheck Time 改名為 DNSCurve Key Recheck Time
  * Client Public Key 改名為 DNSCurve Client Public Key
  * Client Secret Key 改名為 DNSCurve Client Secret Key
  * IPv4 DNS Public Key 改名為 DNSCurve IPv4 Main DNS Public Key
  * IPv4 Alternate DNS Public Key 改名為 DNSCurve IPv4 Alternate DNS Public Key
  * IPv6 DNS Public Key 改名為 DNSCurve IPv6 Main DNS Public Key
  * IPv6 Alternate DNS Public Key 改名為 DNSCurve IPv6 Alternate DNS Public Key
  * IPv4 DNS Fingerprint 改名為 DNSCurve IPv4 Main DNS Fingerprint
  * IPv4 Alternate DNS Fingerprint 改名為 DNSCurve IPv4 Alternate DNS Fingerprint
  * IPv6 DNS Fingerprint 改名為 DNSCurve IPv6 Main DNS Fingerprint
  * IPv6 Alternate DNS Fingerprint 改名為 DNSCurve IPv6 Alternate DNS Fingerprint
  * IPv4 Receive Magic Number 改名為 DNSCurve IPv4 Main Receive Magic Number
  * IPv4 Alternate Receive Magic Number 改名為 DNSCurve IPv4 Alternate Receive Magic Number
  * IPv6 Receive Magic Number 改名為 DNSCurve IPv6 Main Receive Magic Number
  * IPv6 Alternate Receive Magic Number 改名為 DNSCurve IPv6 Alternate Receive Magic Number
  * IPv4 DNS Magic Number 改名為 DNSCurve IPv4 Main DNS Magic Number
  * IPv4 Alternate DNS Magic Number 改名為 DNSCurve IPv4 Alternate DNS Magic Number
  * IPv6 DNS Magic Number 改名為 DNSCurve IPv6 Main DNS Magic Number
  * IPv6 Alternate DNS Magic Number 改名為 DNSCurve IPv6 Alternate DNS Magic Number
* 修復普通格式 Local Hosts 清單讀取錯誤的問題 [muink]
* 修復 Custom 模式下自訂 IPFilter 不能工作的問題
* 修復 SOCKS 4/4a 協定不能工作的問題
* 修復 HTTP CONNECT Proxy 無法正確進行 Basic 驗證的問題
* 修復錯誤報表提供的錯誤代碼格式錯誤的問題
* 修復 CMake 的缺陷造成的錯誤依賴問題 (Linux/macOS) [Syrone Wong]
* 修復程式由於系統 Signal 導致的意外退出問題 (Linux/macOS)
* 修復錯誤詳細資訊有時可能缺少最後一個字元的問題 (Windows)
* 修復 CMake 編譯提示宏重定義的問題 (macOS)
* 移除對 Hosts 檔和 IPFilter 檔的多行注釋支援
* 提供 SHA-2(256)/SHA256 檔校驗值，淘汰 SHA-1 演算法
* Release Hash:
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 65F41F53AAAD9C18828216EC614D276ADE589CBF877B54D7FC7987C05806021D
    * Windows/Pcap_DNSProxy_x86.exe: D84318648F8EFA3DC8667B002DA5211AC2598D6B28D99A95D2DECB84213E898D
    * Windows/Pcap_DNSProxy_XP.exe: C35A23EC22DD3C0ABC0805E2AF7DE8457D7610EAA6E8E9ECAF2931C1C6E6EF96
    * macOS/Pcap_DNSProxy: 7E26203D5F0388ED5D396D2C665FE50E44725BF85CAA6C41088D9A060E5B40E2
  * SHA-2(256):
    * Windows/Pcap_DNSProxy.exe: 3626D21FD0674830F1D13776EB79626D79F653C65108041F8042CA4DDA62B299
    * Windows/Pcap_DNSProxy_x86.exe: 76EC284B340FD7FFA585E8B9DA7E92F54F72AB3FFEA3F9DC1CEAE13B49005266
    * Windows/Pcap_DNSProxy_XP.exe: C4744E588BEE4C15E3BD3B77F1A71E55F8B8C9677F43D6E8691D8B41885AF602
    * macOS/Pcap_DNSProxy: 8C87587D30F6BB6BEE84F6AF07EA27AB77F110BF905CFFDD890ABAB10492F955


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.7.1-0.4.7.6 更新日誌(2016-10-10)：

* 添加對 Dnsmasq 的 Address 和 Server 相容格式設定檔的支援
  * 支援使用 Address 和 Server 相容格式的非正則運算式模式對網域名稱查詢進行字串匹配
  * 支援使用 Server 相容格式指定特定境內 DNS 目標伺服器以及指定目標伺服器請求的埠
  * 附帶的 WhiteList.txt 切換到 Dnsmasq Server 相容格式以降低啟用境內白名單功能時的資源佔用
* 添加一種時間 + 佇列雙重檢測類型的 DNS 緩存策略
* 添加完整的執行緒池支援
* 添加對 RFC 6761 特殊網域名稱標準化解析的支援
  * Localhost Server Name 參數改名為 Local Machine Server Name
  * 修改預設的本機名稱為 pcap-dnsproxy.server
  * 以 localhost 尾碼的網域名稱將全部解析到迴路位址
  * 以 invalid 尾碼的網域名稱將全部解析為網域名稱不存在
  * 以 test 尾碼和 Example Domains 的網域名稱將不作處理
* 添加 CMake 系統並行多執行緒編譯支援 (Linux/Mac)
* 添加伺服器端 TCP Fast Open 屬性的實驗性支援 (Windows)
* 現在輸出錯誤代碼時將附上一段對該錯誤代碼的說明 [Syrone Wong]
* Xcode 更新到 8.0 (Mac)
* 修復通訊端不正確的關閉有可能造成的系統資源耗盡問題 [AVC A]
* 修復 IPv6 協定通訊端參數錯誤的問題 [gaoyan1234]
* 修復 DNS 緩存清除功能的問題 (Linux/Mac) [kiliwalk]
* 修復在不啟用任何 Local 選項同時附帶白名單清單時報錯的問題
* 修復在程式啟動後修改設定檔重新讀取時報錯的問題
* 修復 dig 請求權威根網域名稱伺服器的問題
* 修復 CR + LF 換行格式下行數統計錯誤的問題
* 修復通訊端 TCP Fast Open 屬性不生效的問題 (Linux)
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: 04629413231FCE9CCD375E7E08EED21D975E893B
    * Windows/Pcap_DNSProxy_x86.exe: 771551DFE793F5BD28684BEDBE95A67FB32A0F36
    * Windows/Pcap_DNSProxy_XP.exe: 70E6E5C6974846E19C666A3F2494956DCC731F18
    * Mac/Pcap_DNSProxy: 1D8F5D58681B74BD831C7BBED47E126A273C6AB8
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 0ED522E220D953D5F334FCCCEF1762836C2393AFAD4AD074217A3E5F0E095A4A
    * Windows/Pcap_DNSProxy_x86.exe: 8A1115810A8DA7D3F8A21D37E69A9CBAAF4E0C65B2CB51E60343BD8CDC78D580
    * Windows/Pcap_DNSProxy_XP.exe: 1D96315F010DC6A06A2649589CE214E8E856D49A69D37363BFECD5187FC1C5AD
    * Mac/Pcap_DNSProxy: E730137DA5CE3E6AEBC4EE2180BB45EBF48F8678E7E9A10B1985ADC3C7BF39CA


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.6.1-0.4.7.0 更新日誌(2016-08-22)：

* 添加 Source Hosts 根據網域名稱請求的來源位址進行 Hosts 的功能
* 添加 Local Force Request 參數，可強制已確定使用境內伺服器的網域名稱請求不使用其它伺服器進行解析
* 添加 --flush-dns 參數指定網域名稱功能，可清除特定網域名稱的緩存
* 添加遺漏的 DNS 投毒污染黑名單位址
* 添加實驗性的執行緒池支援，並將 Buffer Queue Limits 參數更名為 Thread Pool Maximum Number
* 添加對刷新系統緩存的時間間隔限制 [Syrone Wong]
* 添加 CMake 的 Clang 編譯器支援 (Mac)
* LibSodium 庫更新到 1.0.11 (Windows/Mac)
* Multi Request Times 參數更名為 Multiple Request Times
* Alternate Multi Request 參數更名為 Alternate Multiple Request
* 合併 KeyPairGenerator 工具到主程式，作為支援參數使用
* 分離 32 位版本對 XP/2003 系統的支援 (Windows)
* 修復資料包過濾模組過於嚴格導致無法使用部分正常 DNS 伺服器的問題 [muink]
* 修復批次處理在 2003 系統下無法正常工作的問題 (Windows) [wuxiao2522]
* 修復抓包模組錯誤判斷正確資料包的問題
* 修復抓包模組對 IPv6 資料包識別錯誤的問題
* 修復 Pcap Devices Blacklist 參數工作不正常的問題
* 修復 Hop Limits/TTL 參數讀取不正常的問題
* 修復 Hop Limits/TTL 參數指定的值被覆蓋的問題
* 修復由於部分通訊端被過早清理造成系統協定棧返回 ICMP/ICMPv6 埠不可達資訊的問題
* 移除附帶的 FileHash 工具，其將分離至 https://github.com/chengr28/Toolkit 專案繼續開發
* 移除對舊版設定檔的相容
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: DA363FB8F5E3906A1FB65464A0E1343C747DA72C
    * Windows/Pcap_DNSProxy_x86.exe: 96F508BBDB48DD16B0B13D7B58D42F333042F198
    * Windows/Pcap_DNSProxy_XP.exe: 07DB9B0D32E5314E8D46A13F02014D712CD1761D
    * Mac/Pcap_DNSProxy: 9B5EF5662DF6697E0FA5DC66B000EA56996FE30C
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: E51761D6A7F5EDC505CC6281CF880D70EC2828904BC34A133C89875A31499B47
    * Windows/Pcap_DNSProxy_x86.exe: D50D4218D14C8C62F67F3BE845B4D668994D807A8A85C2D8D432C50BEB7E1709
    * Windows/Pcap_DNSProxy_XP.exe: D7342D887B52C4FA87402FF9C4273E7C6F6461CA01FDCADC92253D06FD8E8072
    * Mac/Pcap_DNSProxy: DBF31E10FD8BBA080D16256F2DB062B106A157831C3B9DE2824C61890A63A429


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.5.1-0.4.6.0 更新日誌(2016-04-23)：

* 為 FileHash 工具添加 Hash 演算法支援
  * CRC family: CRC-8 family + CRC-16 family + CRC-24 family + CRC-32 family + CRC-40 + CRC-64 family
    * CRC-8 family: Normal + ITU + ATM + CCITT + Maxim + Icode + J1850 + WCDMA + Rohc + Darc
    * CRC-16 family: Normal + Buypass + DDS 110 + EN 13757 + Teledisk + Modbus + Maxim + USB + T10 DIF + DECT(X) + DECT(R) + Sick + DNP + CCITT Xmodem + CCITT FFFF + CCITT 1D0F + Genibus + Kermit + X25 + MCRF4XX + Riello + Fletcher
    * CRC-24 family: Flexray A + Flexray B + R64(Normal)
    * CRC-32 family: Normal + JamCRC + C + D + BZIP2 + MPEG2 + POSIX + K + Q
    * CRC-64 family: Normal + 1B + WE + Jones
  * Checksum: Internet Protocol Checksum
  * SHA family: SHA-2(384) + SHA-2(512) + SHA-2(512/224) + SHA-2(512/256)
  * MD family: MD2 + MD4 + eD2k Hash + MD5
* 添加抓包模組對 Virtual Bridged LAN/IEEE 802.1Q 標籤的支援
* 添加 IPv4 Packet TTL 和 IPv6 Packet Hop Limits 參數，支援指定和隨機化的 TTL/Hop Limits 值
* 添加 Update_WhiteList 工具，可自動更新白名單網域名稱清單 [dgeibi]
* 添加錯誤日誌輸出分級功能，並將 Print Error 參數更名為 Print Log Level [smounives]
* 添加 IPv4 Do Not Fragment 參數，支援指定 Do Not Fragment 標誌 (Windows/Linux)
* 添加 Update_Routing 工具的自動更新腳本 (Linux/Mac)
* 通過外部命令清除程式內部 DNS 緩存的過程，現在將能無延遲地立即完成
* 增強對 EDNS Label 的精細化控制
* LibSodium 庫更新到 1.0.10 (Windows/Mac)
* Visual Studio 更新到 2015 (Windows)
* Xcode 更新到 7.2 (Mac)
* IPv4 TTL 參數更名為 IPv4 DNS TTL
* IPv4 Alternate TTL 參數更名為 IPv4 Alternate DNS TTL
* IPv6 Hop Limits 參數更名為 IPv6 DNS Hop Limits
* IPv6 Alternate Hop Limits 參數更名為 IPv6 Alternate DNS Hop Limits
* 修復白名單清單不工作的問題 [lonsx]
* 修復白名單/黑名單清單在 CNAME Hosts 區域內不生效的問題 [shuangzhijinghua]
* 修復一個特定情況下可能導致程式崩潰的問題
* 修復因 errno 造成的錯誤代碼延續問題 [Syrone Wong]
* 修復 Additional Path 失效的問題 [jzp820927]
* 修復 Additional Path/Hosts File Name/IPFilter File Name 參數大小寫和空格相容問題
* 修復使用 Win10Pcap 時抓包模組不能工作的問題 (Windows) [smounives]
* 修復在抓包模式下 CNAME Hosts 格式錯誤的問題 [debugzxcv]
* 修復程式內部 DNS 緩存被錯誤自動清除的問題 (Linux/Mac)
* 修復 Update_Routing 工具在 ICMP/ICMPv6 協定被遮罩的網路下不能工作的問題 (Windows) [w48325832/Syrone Wong]
* 修復重啟服務間隔時間過短可能導致的崩潰問題 (Windows)
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: 8805389165915A4611458B28A5C98303F7A6BC6F
    * Windows/Pcap_DNSProxy_x86.exe: 27C6219FFB2A225A56E6D3186B7BE299535DF1F7
    * Mac/Pcap_DNSProxy: 14B86B5CA6BF38D7A242279C2164F53E383CAC52
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 72930EBF627021684C10C4BBC0988BBBF9CC3F38BE53E93DC4152494CEF88D7F
    * Windows/Pcap_DNSProxy_x86.exe: 04DF32B593D26019545AF121F8551B1632905A7A85506D11E8F83BD174A8C188
    * Mac/Pcap_DNSProxy: 0091474FAEB8CAB2FEF225BCA646A3D46DC0E957FF8AF6F49B8E4FCB9990C1C1


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.4.1-0.4.5.0 更新日誌(2015-12-30)：

* 添加 FileHash 工具，提供對檔的校驗功能
* 支援 SHA-1
* 支援 SHA-2(224/256)
* 支援 SHA-3(224/256/384/512/SHAKE_128/SHAKE_256)
* 添加對 SOCKS 版本 4/4a/5 請求的原生支援
* 添加對 HTTP CONNECT Tunnel 請求的原生支援
* 添加對 CNAME Hosts 的支援 [Hugo Chan/shuangzhijinghua/debugzxcv]
* 添加 DNSCurve Reliable/Unreliable Socket Timeout 參數，增強對不同協定超時設定的精細化控制
* 添加 --lib-version 參數，可輸出程式現正使用的庫的版本號資訊
* EDNS Client Subnet 參數現在更名為 EDNS Client Subnet Relay 並修改了此參數的含義 [XIAOSpider97]
* 增進 DNSCurve 部分的安全性
* LibSodium 庫更新到 1.0.8 (Windows/Mac)
* 升級專案檔案到 Xcode 7.1 (Mac)
* 調整 GCC 最低版本要求為 4.9 (Linux)
* 調整二進位版本最低系統要求為 10.8/Mountain Lion (Mac)
* 修正 EDNS Client Subnet 功能的轉發策略 [XIAOSpider97]
* 修正抓包模組的工作條件 [軒轅無雙]
* 修復讀取 IPv4 路由表 CIDR 時的錯誤 [hocoo]
* 修復 DNS flag AD/Authentic Data 錯誤設置的問題 (Linux/Mac)
* 修復 DNS ID mismatch 的錯誤 (Linux/Mac) [hongyi-zhao/cielpy]
* 修復監視模組可能出現的休眠錯誤 [shuangzhijinghua]
* 修復多次啟動程式時可能造成的崩潰問題 (Windows)
* 修復主控台輸出內容混疊的問題 (Windows)
* Release Hash:
  * SHA-1:
    * Windows/Pcap_DNSProxy.exe: AC94CDFD0F69A336DE9BFC4A877E3468BFCFAD0C
    * Windows/Pcap_DNSProxy_x86.exe: 938FD04259497D2DD8204F91E51F0B99B108BE57
    * Mac/Pcap_DNSProxy: A9765A1BE67999036C80061CFC66C7EE0191CF90
  * SHA-3(256):
    * Windows/Pcap_DNSProxy.exe: 4CFC917AFD6DE227710CBBA5B6C8A6A4F0BDF8216E9FBE8B26E1F195F2E8AD12
    * Windows/Pcap_DNSProxy_x86.exe: CF36584F70E1EE30F0AB1FB445A4D0971067540F7F7BA3C45C0F0B08984A9066
    * Mac/Pcap_DNSProxy: C653A3DA815BDF5C8995803F105DB666ADB31EC57C942411297469D69C4CA7F9


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.3.1-0.4.4 更新日誌(2015-09-27)：

* 添加 Client Ephemeral Key 一次性用戶端金鑰組功能，增強 DNSCurve 協定傳輸資料的安全性 [DNSCrypt]
* 添加對設定檔部分參數的自動刷新功能，具體受支援的參數參見說明文檔 [jedisct1/icylogic]
* 添加 Local Protocol 參數用於指定請求境內伺服器時所使用的協定組合 [muink]
* 添加對十六進位 DNSCurve(DNSCrypt) 協定 Magic Number 參數的支援 [BiliBbb]
* 增強 DNSCurve Protocol 參數對協定組合的支援
* 增強 Null 擴展 Hosts 白名單功能的支援，現在可以指定只對部分 DNS 類型生效
* 添加對 BIND 9.2.0 之後版本清除 DNS 緩存的命令 (Linux) [hongyi-zhao]
* 修正 Local Main 模式生效時對 Local Hosts 清單的讀取策略 [c1024/gaoyan1234]
* 修正 Receive Waiting 參數的含義以及對請求行為的影響
* 修正 Local Hosts 參數啟用時解析網域名稱的流程，提高已緩存解析結果的解析速度 [hongyi-zhao]
* 修正對並行請求的數量限制
* 修復部分參數讀取使用網路層服務名/DNS 記錄名稱代替數位時的錯誤
* 修復多執行緒模式下伺服器連接失敗時無法切換的問題
* 修復 TCP 協定請求時可能造成的分片問題
* 修復 ICMP/ICMPv6 附加資料長度的計算問題
* 修復 32 位系統對 IPv4/IPv6 位址轉換的錯誤 (Windows Vista+) [Nine Forty/fabe004]
* 修復 ICMP/ICMPv6 通訊端參數在預設情況下造成 Ping 功能不正常的問題 (Linux/Mac)
* 修復啟用 TCP 協定時 Local 請求造成程式崩潰的問題 (Linux/Mac)
* 修復 Additional Path 參數讀取不完全的問題 (Linux/Mac)
* 修復不啟用 TCP Fast Open 時發送請求可能會出現的問題 (Linux)
* 修復重新讀取 IPFilter 和 Hosts 檔時的順序問題
* 修復部分情況下不輸出 Error.log 檔的錯誤 (Linux/Mac) [hongyi-zhao]
* 移除清除 DNS 緩存失敗時錯誤訊息的輸出，此消息對運行沒有影響 [Syrone Wong]


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.2.1-0.4.3 更新日誌(2015-07-28)：

* Hosts Only 參數現在更名為 Direct Request 並支援指定 IPv4 或 IPv6 功能
* 添加不同協定的 Direct Request 功能 [AVC A]
* 添加 Pcap Devices Blacklist 參數，可指定不對含有此名稱的網路介面卡進行抓包
* 添加限制請求數量的功能
* 添加 DNS 壓縮指標檢查功能，避免接受格式錯誤的資料包
* 添加遺漏的 DNS 投毒污染黑名單位址
* 添加對 Unicode 標準包含的所有換行以及空格類別格式的支援
* 添加對 TCP Fast Open 的支援 (Linux)
* 添加 --disable-daemon 參數，可控制程式是否以 Daemon 守護進程的方式運行 (Linux)
* 添加完整的 ASCII/UTF-8/UTF-16(LE/BE)/UTF-32(LE/BE) 編碼支援
* 調整抓包模組為回檔模式降低資源的佔用
* 調整抓包模組工作模式，避免 WinPcap 與 cFosSpeed 之間的衝突 [軒轅無雙]
* 優化優先指定網路層協定功能
* 優化對大小寫敏感字元的讀取
* 優化對 Hosts 和 Local Hosts 的讀取和檢測 [yuyangzxw/gaoyan1234]
* 修復抓包模組非 Ethernet 和 Apple IEEE 1394/FireWire 設備的錯誤識別
* 修復資料包過濾模組的演算法錯誤 [AVC A]
* 修復檔讀取模組對於前後留空的錯誤 [wen kangcheng]
* 修復檔讀取模組對於多重空格處理的問題 [yuyangzxw]
* 修復 KeyPairGenerator 生成用戶端金鑰組的錯誤 [Syrone Wong]
* 修復 Accept List 參數讀取 DNS 類型名稱的錯誤 [Syrone Wong]
* 修復 Address Hosts 功能溢出錯誤 [jzp820927]
* 修復當請求的資料中帶有 EDNS Label 時的錯誤 [Syrone Wong]
* 修復收到截斷資料包時無法重新按照標準適用 TCP 協定重新解析的錯誤 [shuangzhijinghua]
* 修復睡眠或休眠前可能產生的錯誤報表輸出 (Windows)
  * 啟動第一次遇到 Insufficient privileges or not any available network devices 錯誤資訊時將暫時不輸出到錯誤報表檔
  * 移除 An error occurred in XXX 錯誤資訊
* 終端視窗也將輸出錯誤資訊
  * 運行在非 Daemon 守護進程模式下的終端視窗時 (Linux)
  * 任何時候 (Mac)
* 移除服務管理批次處理的強制管理員許可權請求 (Windows) [5sq]


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.1.1-0.4.2 更新日誌(2015-06-04)：

* 添加對 EDNS Client Subnet 的支援
* 增強對 DNSSEC 的請求能力以及添加不完整的認證功能
* 添加對 Local 境內 DNS 伺服器的路由表檢查，但只會進行提示而不會中斷程式的運行
* 添加 DNSSEC Force Validation 參數，可強制攜帶 DNSSEC 記錄的網域名稱解析才能被接受
* 添加 -c/--config-file 參數，可在啟動時指定設定檔的目錄 [BlackGear]
* 添加 -v/--version 參數，可輸出程式的版本號 [BlackGear]
* 添加對 homebrew 的支援 (Mac) [BlackGear]
* 添加可用於卸載服務的 Shell 腳本 (Linux/Mac)
* 添加不終止程式運行的錯誤提示類型
* 為 Protocol 參數添加優先指定網路層協定功能
* 設定檔新增 cfg 副檔名的支援
* 修改讀寫執行許可權的設置，以增加安全性 [BlackGear]
* EDNS0 Label 參數改名為 EDNS Label


-------------------------------------------------------------------------------


Pcap_DNSProxy 0.4.0.1-0.4.1 更新日誌(2015-05-21)：

* 添加 Pcap Reading Timeout 參數自訂抓包模組讀取超時/間隔時間
* 添加 Receive Waiting 參數自訂資料包接收等待時間，丟棄過早達到可能為偽造的資料包
* 添加剝離 LibPcap 庫的選項 (Linux)
* 調整抓包模組的超時時間保證回復及時被抓取 [France is Bacon]
* 調整資料包過濾的參數避免誤傷部分權威 DNS 伺服器 [France is Bacon]
* 調整 DNS 緩存的機制只緩存有結果的資料包 [shuangzhijinghua]
* 視窗模式運行提示將不會寫入錯誤報表中 (Windows)
* 修復 Hosts 條目過長導致資料包溢出的問題 [yfdyh000]
* 修復 Local Hosts 無法讀取的問題 [France is Bacon]
* 修復 Hosts 添加 EDNS 標籤的問題
* 修復隨機網域名稱生成模組產生非標準網域名稱查詢的錯誤
* 調整在關閉抓包模組時請求網域名稱解析的策略
* 移除覆蓋系統 Hostname 的行為 (Mac) [messiahluo]
* 移除之前尚未完成的列印詳細運行日誌的功能


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.4(Windows/Linux/Mac) 更新日誌(2015-05-12)：

* 添加對 Apple IEEE 1394/FireWire 的支援
* 添加對 Streamlined/精簡格式 DNSCurve(DNSCrypt) 協定的支援
  * 提供隨機 Curve25519/Salsa20/Poly1305(DNSCurve) 金鑰組生成程式 KeyPairGenerator
* 添加緩存 DNS 回復包的功能
* 添加切換待命伺服器，提供主要伺服器和待命伺服器自動切換的功能
  * 可自訂切換的條件（請求失敗次數、失敗次數計數週期、重置切換的時間長度）
* 添加 Local Main 主要境內伺服器請求功能
  * 即平時使用 Local 伺服器進行解析，遇到遭投毒污染的解析結果時自動再向境外伺服器請求
  * 解析的結果是否會被投毒污染與使用的偽包篩檢程式有關，詳細情況參見說明文檔
* 添加接收到一個解析請求向同一個遠端伺服器發送多次解析請求的功能，可提高遠端伺服器丟包時網域名稱解析的可靠性
* 添加自訂請求伺服器埠的功能
* 添加自訂本地監聽位址和埠的功能
* 添加本地多監聽位址/多監聽埠的功能
* 添加以 DNS 請求的類型為條件的遮罩功能
* 添加 IPv6 6to4/ISATAP/Teredo 隧道的支援
* 為本機伺服器監聽 IPv4/IPv6 增加控制選項（請求時相同協定優先，不同協定 IPv6 優先）
* 添加 Domain Case Conversion/隨機轉換網域名稱請求大小寫 的功能，預設為開啟
* 添加 Compression Pointer Mutation/隨機添加壓縮指標 的功能，預設為關閉
* 為抓包模組添加總開關 Pcap Capture
* 為抓包模組添加 IPv4 擴展頭部的支援
* 為 TCP Data Filter/TCP 資料包篩檢程式添加檢查 Checksum/校驗和的功能
* 為 IPv4/IPv6 黑名單位址過濾功能添加新的投毒污染位址
* 黑名單位址過濾功能應用到所有解析過程以避免權威伺服器被污染的情況下所有結果被投毒污染的結果
* 為 Operation Mode 增加 Private 和 Custom 模式 [陳斐]
  * Private 模式只允許私有網路請求解析
  * Custom 模式禁止或只允許清單中的位址請求解析，使用單獨的位址過濾庫（支援 IPFilter.dat 和 Guarding.P2P 格式）進行控制
* 為 IPFilter 位址過濾庫添加黑名單解析結果過濾功能
* 添加對超過 UDP 協定最大不分片長度的截斷資料包使用 TCP 協定重試的功能
* 添加對 EDNS 標籤和 DNSSEC(AD/CD/DO) 請求功能的支援（開啟 DNSSEC 請求後必須強制添加 EDNS 標籤）
* 添加 Hosts Only 直連模式只使用本工具具有正則運算式的 Hosts 功能
* 添加 Local Routing 本地路由表功能
* 添加自訂 Hosts 存留時間的功能
* 程式設定檔和 Hosts 檔版本升級到 v0.4
  * 支援的一行最大長度增到 4KB/4096 bytes
  * 添加新的單行和多行注釋格式支援
  * 為 Hosts 檔添加 CSV/逗號分隔值 格式的支援
  * 為 Hosts 檔添加 "BANNED 正則運算式"（不含引號）語法直接返回網域名稱查找失敗資訊，用於快速遮罩網域名稱
  * 為 Hosts 檔添加 "BANNED:xxx 正則運算式"（不含引號）語法遮罩特定類型記錄的網域名稱查詢
  * 為 IPFilter 資料庫添加 "IP位址 ALL"（不含引號）語法直接遮罩所有含此 IP 位址/位址範圍的解析結果
  * URI 標準化 IPv6 位址格式，IPv4/IPv6 位址格式更改為帶埠格式
  * 支援部分非標準的縮略 IPv4/IPv6 位址格式
  * 支援檢查檔案大小的功能
  * 支援自訂檔最大佔用空間的設定
  * 支援自訂 Hosts 和 IPFilter 資料庫檔案名稱的功能
  * 為資料庫添加排序的功能，避免因為錯誤的順序造成問題
  * 在開啟散列演算法特徵檢測檔改變以及開啟 DNS 緩存的情況下，自動更新 Hosts 清單和 IPFilter 資料庫時將自動清空程式的 DNS 緩存
  * 在開啟散列演算法特徵檢測檔改變的情況下，自動更新 Hosts 清單時將自動清空系統 DNS 緩存
  * 重寫文字檔編碼讀取模組，支援混合換行格式編碼（但不建議使用）
  * 可相容 v0.3 以前的檔版本，但強烈建議升級為當前版本 v0.4
* 添加視窗模式以支援在安全模式下的運行 (Windows)
* 錯誤報表在視窗模式下現在會即時顯示 (Windows)
* 添加剥离 Libsodium 库的选项 (Linux)
* 請求本機伺服器的完整網網域名稱稱現在會返回本機伺服器的所有 IPv4/IPv6 位址
* 調整請求本地 DNS 伺服器由抓包模式到直連模式，加快回應速度降低資源佔用
* 調整 IPv4 Data Filter/IPv4 資料包篩檢程式，預設為關閉
* 調整 ICMP 和隨機網域名稱請求模組的編號和序號建置規則
* 調整 ICMP 附加資料限制長度最長到 1464 bytes(Ethernet MTU - IPv4 Standard Header - ICMP Header)
* 調整隨機網域名稱生成模組，使用 C++ STL 提供的梅森旋轉演算法引擎產生離散型均勻分佈的隨機網域名稱
* 調整內置預設本機伺服器完整網網域名稱稱為 "pcap-dnsproxy.server"（不含引號）以遵循網域名稱系統的標準
* 調整記憶體分配策略（標準乙太網 MTU 長度、資料包緩衝區長度和 STL 標準庫調用）減少資源佔用
* 調整錯誤報表為帶 BOM 的 UTF-8 編碼，避免可能產生的亂碼問題 [Hugo Chan]
* 調整正則運算式為完全符合模式，提供更準確的匹配效果 [Hugo Chan]
* 合併 x86 和 x64 版本可執行檔 (Windows) [Hugo Chan]
* 改進初次開機時進行的防火牆測試模組(Windows)
* 改進無法找到或禁用重啟網路介面卡後自動重試的功能
* 改進抓包模組的回復機制，降低資源佔用
* 使用 CMake 套裝編譯 (Linux)
* 為 Debian 系 Linux 發行版本提供服務控制腳本自動安裝腳本
* 移除建置錯誤報告
  * 找不到 Hosts 檔時
  * Windows XP 系統下不支援 IPv6 時
* 修復超過額定長度（本次更新前為 2 KB）的檔讀取能會造成的錯誤
* 修復 UDP 協定下過早關閉埠造成系統發送 ICMP(v6) Port Unreachable 埠不可到達資訊的錯誤
* 修復 TCP 協定下因為遠端伺服器無回應而造成的過長時間不回應請求的錯誤
* 修復存在橋接器配接器時可能造成的崩潰 [JonyOang]
* 修復多執行緒模型下競爭讀寫全域物件可能造成的錯誤
* 修復本地監聽埠可能被盜用的安全問題 (Windows)
* 修復因為系統預設 IPv6/IPv4 通訊端配置造成的衝突問題 (Linux)
* 修復自身伺服器名稱讀取和 IPv6 環境下回複自身伺服器名稱的錯誤
* 修復反向解析網域名稱時回復自身伺服器名稱到所有私有網路位址對應網域名稱的錯誤
* 修復在 IPv6 環境下抓包回復時的匹配錯誤
* 修復網路介面卡被禁用重啟後 WinPcap/Libpcap 無法抓取資料包的錯誤
* 修復特殊 IPv4/IPv6 位址檢測模組的錯誤
* 修復隨機網域名稱生成模組可能生產空網域名稱(ROOT)的錯誤
* 修復超長 Hosts 條目可能導致的溢出錯誤以及最短長度限制的問題
* 修復部分情況下無法讀取檔最後一行的錯誤 [Hugo Chan]
* 服務現在將設定為在第一次和第二次遇到錯誤時自動重新開機 (Windows) [yfdyh000]
* 程式啟動時將不再刪除錯誤和運行日誌檔 [yfdyh000]
* 合併批次處理 (Windows) [yfdyh000]
* 修復批次處理在開啟 UAC 的情況下無法使用的錯誤(Windows) [Haruyuki Arita/Hugo Chan/Ryans233/streamgo/watchingyoufall]
* 在非管理員許可權下運行批次處理無法修改系統服務資訊的錯誤現在將有提醒(Windows) [Haruyuki Arita/Hugo Chan/Ryans233/watchingyoufall]
* 原始程式碼現在開始將使用 UTF-8 編碼
* 專案升級到 Visual Studio 2013 (Windows)
* 修復在 IPv6 環境下抓取來自境內網域名稱解析伺服器回復包的錯誤，但此功能在新版已被移除，特此公告 [David Webb/eqielb]
* 修復 Makefile 的錯誤，但此功能在新版已被移除，特此公告 (Linux) [otakuchiyan]


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.3.2(Windows)/v0.2(Linux)/v0.1(Mac) 更新日誌：

* Pcap_DNSProxy v0.1 Mac Release 正式發佈！
* 提供可用於 x86 和 x64 環境的可執行檔 (Linux)
* 啟用對 Ethernet 設備的識別 (Linux)
* 修復在錯誤使用低許可權運行程式可能造成的 bug
* 修復在部分情況下錯誤建置錯誤報告的 bug (Linux)
* 修正說明文檔的錯誤操作 (Linux)


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.3.1(Windows)/v0.1(Linux) 更新日誌：

* Pcap_DNSProxy v0.1 Linux Release 正式發佈！
* 剝離並更新 IPv4/IPv6 保留地址清單過濾模組 (Windows)
   * 升級解析結果黑名單位址過濾功能
   * 修復本地 IPv6 位址獲取功能的 bug
   * 修復自動刷新本地位址的 bug
* 修復本地可郵寄地址識別錯誤的 bug (Windows)


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.3 更新日誌：

* 32 位/x86 版本使用 WSAAddressToString() 和 WSAStringToAddress() 替代 inet_ntop() 和 inet_pton() 以支援 Windows XP 以及更舊的系統 [Roy Tam]
* 添加對固定清單網域名稱請求境內網域名稱解析伺服器的功能 [陈斐]
* 為 Windows 防火牆測試添加 IPv6 版本支援
* INI 版本和 Hosts 版本更新至 0.3
  * 為設定檔添加版本檢測功能
  * 為 Hosts 添加白名單功能
* 更新設定檔讀取模組
  * 修復部分編碼/換行格式下錯誤輸出行數至錯誤報表的 bug
  * 修復 Hosts 檔一定情況下錯誤識別注釋的 bug
  * 增強對不同換行格式的識別
* 修復 ICMP(v6)/Ping 測試模組的 bug
* 修復白名單網域名稱請求測試在 TCP 模式下被禁用的 bug
* 修復 WinPcap 抓取資料包執行緒退出後可能導致的記憶體洩漏問題
* 注釋 Console 和部分 Ethernet 的調試代碼
* 原始程式碼全部轉為 USC-2(Little-Endian) 編碼和 Windows(CR-LF) 檔案格式


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.2 更新日誌：

* 重寫編碼讀取模組，新增支援 Macintosh(CR) 換行格式
* 修復無法在 PPPoE 環境下使用的 bug
* 使用C語言標準庫傳回值
* 巨集定義錯誤報表類型


-------------------------------------------------------------------------------


Pcap_DNSProxy v0.1 更新日誌：

* v0.1 Release 正式發佈！
